<?php
// cssedit.inc.php for PukiWiki available under the GPL
//       by teanan / Interfair Laboratory 2005.
//

define('CSSEDIT_FILE_SCREEN_DEFAULT', SKIN_DIR . 'css.screen.default.dat');
define('CSSEDIT_FILE_PRINT_DEFAULT',  SKIN_DIR . 'css.print.default.dat');
define('CSSEDIT_FILE_SCREEN',         SKIN_DIR . 'css.screen.dat');
define('CSSEDIT_FILE_PRINT',          SKIN_DIR . 'css.print.dat');

function plugin_cssedit_action()
{
	global $script, $vars, $_msg_invalidpass;

	$pass  = isset($vars['pass']) ? $vars['pass'] : NULL;
	$media = isset($vars['media']) ? $vars['media'] : NULL;

	$msg  = 'cssedit';
	$body = '';
	if ($pass !== NULL) {
		if (isset($vars['update']) || isset($vars['default'])) {
			if(pkwk_login($pass)) {
				plugin_cssedit_update($media, isset($vars['default']));
			} else {
				$body  = "<p><strong>$_msg_invalidpass</strong></p>\n";
			}
		} else {
			if(pkwk_login($pass)) {
				// css edit form
				$body = plugin_cssedit_edit_form($media);
			} else {
				$body  = "<p><strong>$_msg_invalidpass</strong></p>\n";
				$body .= plugin_cssedit_password_form();
			}
		}
	} else {
		$body = plugin_cssedit_password_form();
	}
	return array('msg'=>$msg, 'body'=>$body);
}

function plugin_cssedit_password_form()
{
	global $script;

	return <<<EOD
<form action="$script" method="post">
 <div>
  <input type="hidden"   name="cmd"  value="cssedit" />
  Password
  <input type="password" name="pass" size="12" />
  <input type="radio" name="media" value="screen" checked="checked" /> screen
  <input type="radio" name="media" value="print" /> print
  <input type="submit"   name="ok"   value="OK" />
 </div>
</form>
EOD;

}

function plugin_cssedit_edit_form($media)
{
	global $script, $rows, $cols;

	$body = '';

	list($cssdata_name, $default_name) =
		plugin_cssedit_get_cssfilename($media);

	if(!file_exists($cssdata_name)) {
		if(!file_exists($default_name)) {
			die_message("cssedit.inc.php: Cannot open $default_name");
		}
		$postdata = join('', file($default_name));
	} else {
		$postdata = join('', file($cssdata_name));
	}

	$s_postdata = htmlspecialchars($postdata);
	$s_media = htmlspecialchars($media);	// ǰΤ
	$s_pass  = htmlspecialchars($pass);		// ǰΤ

	$body .= <<<EOD
<form action="$script" method="post">
 <div>
  <input type="hidden"   name="cmd"   value="cssedit" />
  <input type="hidden"   name="media" value="$s_media" />
  <textarea name="cssdata" rows="$rows" cols="$cols">$s_postdata</textarea>
  <br />
  Password
  <input type="password" name="pass" size="12" />
  <input type="submit"   name="update"   value="" />
  <input type="submit"   name="default"  value="᤹ͤ" />
 </div>
</form>
EOD;

	return $body;
}

// Update CSS file (write default settings when $setdefault == TRUE)
function plugin_cssedit_update($media, $setdefault = FALSE)
{
	global $script, $vars;

	list($cssdata_name, $default_name) =
		plugin_cssedit_get_cssfilename($media);

	if ($setdefault) {
		// ᤹ͤ
		if(!file_exists($default_name)) {
			die_message("cssedit.inc.php: Cannot open $default_name");
		}
		$postdata = join('', file($default_name));
	} else {
		// ͽ񤭹
		$postdata = isset($vars['cssdata']) ? $vars['cssdata'] : '';
	}

	$fp = fopen($cssdata_name, 'w');
	set_file_buffer($fp, 0);
	flock($fp, LOCK_EX);
	rewind($fp);
	fwrite($fp, $postdata . "\n");
	flock($fp, LOCK_UN);
	fclose($fp);

	// return to TopPage
	header('Location: ' . get_script_uri());
	exit;
}

function plugin_cssedit_get_cssfilename($media)
{
	if($media=='screen') {
		$cssdata_name = CSSEDIT_FILE_SCREEN;
		$default_name = CSSEDIT_FILE_SCREEN_DEFAULT;
	} else if($media=='print') {
		$cssdata_name = CSSEDIT_FILE_PRINT;
		$default_name = CSSEDIT_FILE_PRINT_DEFAULT;
	} else {
		die_message("cssedit.inc.php: Invalid media '$media'");
	}

	return array($cssdata_name, $default_name);
}
?>
